/*
 * populates_stack.c --implements function for populating the program stack
 * 
 *
 * Authored by Alex Stratford
 */

#include <string.h>
#include "threads/vaddr.h"
#include "userprog/argument_parsing.h"

 // Adds the move value to the stack pointer
static void move_stack_pointer(void** stack_pointer, int move_value) {
	*stack_pointer = *stack_pointer + move_value;
}

void populate_stack(void** stack_pointer, int argc, char** argv) {
	*stack_pointer = PHYS_BASE;
	int i = argc;
    
	uint32_t * arr[argc];	// Creates an array to hold arguments in the stack

	while (--i >= 0)
	{
		*stack_pointer = *stack_pointer - (strlen(argv[i]) + 1) * sizeof(char);

		arr[i] = (uint32_t *)*stack_pointer;	// Assigns the current reference of the stack pointer to the array

		memcpy(*stack_pointer, argv[i], strlen(argv[i]) + 1);
	}

    move_stack_pointer(*stack_pointer, -4); //Moves the stack pointer back 4

	(*(int *)(*stack_pointer)) = 0;//sentinel          
	i = argc;

	while (--i >= 0)
	{
		move_stack_pointer(*stack_pointer, -4); //32bit  Moves the stack pointer back 4

		(*(uint32_t **)(*stack_pointer)) = arr[i];
	}
	
	move_stack_pointer(*stack_pointer, -4);
    move_stack_pointer(*stack_pointer, 4); //Moves the stack pointer forwards 4
    // TODO: Test if still required in later version
    
	(*(uintptr_t  **)(*stack_pointer)) = *stack_pointer;
	move_stack_pointer(*stack_pointer, -4); //Moves the stack pointer back 4

	*(int *)(*stack_pointer) = argc;
	move_stack_pointer(*stack_pointer, -4); //Moves the stack pointer back 4

	(*(int *)(*stack_pointer)) = 0;
}